<?php 
// require 'config.php';

###########################################################################
############################### CONFIG OF APP #############################
###########################################################################

define('URL_BX', 'https://emin.bitrix24.com.br/rest/96/glxl54nwag3dz2qb/');
define('DEBUG_FILE_NAME', 'contasEndpoint.log');
define('SLEEP_FOR', 1);

define('TKN', 'm09xiuq8yu0hj7wj7d0fppz9yo7ot83v');

header("Access-Control-Allow-Origin: *");
header('Cache-Control: no-cache, must-revalidate'); 
header("Content-Type: text/html; charset=UTF-8");
header("HTTP/1.1 200 OK");

###########################################################################
########################## Auxlilary Functions ############################
###########################################################################

function writeToLog($data, $title = '')
{
	if (!DEBUG_FILE_NAME)
		return false;

	$log = "\n------------------------\n";
	$log .= date("Y.m.d G:i:s")."\n";
	$log .= (strlen($title) > 0 ? $title : 'DEBUG')."\n";
	$log .= print_r($data, 1);
	$log .= "\n------------------------\n";

	file_put_contents(__DIR__."/".DEBUG_FILE_NAME, $log, FILE_APPEND);
	return true;
}

/* Função auxiliar para exibir dados dos vetores retornado na requisição e escrita no .log */
function getJson($url, $array, $print = 1){
    
    
    $queryData = http_build_query($array);

    $curl = curl_init();
	curl_setopt_array($curl, array(
								CURLOPT_SSL_VERIFYPEER => 0,
								CURLOPT_POST => 1,
								CURLOPT_HEADER => 0,
								CURLOPT_RETURNTRANSFER => 1,							
								CURLOPT_URL => $url."?start=".$start,
								CURLOPT_POSTFIELDS => $queryData,
								));
	$result = curl_exec($curl);
	curl_close($curl);

	$result = json_decode($result, 1);
	
	
	if (array_key_exists('error', $result)){

        echo "Error: ".$result['error_description']."<br/>";

        // writeToLog("Error: ", $result);

    }
	
	if($print == 1){
	    printArray($url);
	    printArray($array);
	    printArray($result);
	}
	
	sleep(SLEEP_FOR);

	return $result;
    
}

function printArray($array){
    echo "<pre>";
    print_r($array);
    echo "</pre>";
    
    writeToLog($array, 'printArray');
}

function formatDate($date){
    
    $new = explode(" ", $date);
    
    return $new[0]."T".$new[1]."-03:00";

}

function cleanDate($date){
    $newdate = date("d/m/Y", strtotime($date));
    return $newdate;
}

function getName($nome, $parte){
    
    $nome = explode(" ", $nome);
    
    if($parte == 1){ // Primeiro Nome

        return $nome[0];

    }elseif($parte == 2){ // Nome Meio (2º)

        return $nome[1];

    }elseif($parte == 3){ // Sobrenomes
        $last_name = '';
        foreach($nome as $key => $value){
            if($key > 1){
                $last_name.= $value." ";
            }
        }
        return trim($last_name);
        
    }elseif($parte == 4){ // Tudo menos PRIMEIRO
        $last_name = '';
        foreach($nome as $key => $value){
            if($key >= 1){
                $last_name.= $value." ";
            }
        }
        return trim($last_name);
    }

}

function addFeed($id, $mensagem, $entity, $print = 0){
    
    $queryUrl = URL_BX."crm.livefeedmessage.add";
    
    $fields = array(
                'fields' => array(
						 	"POST_TITLE" => $id,
						 	"MESSAGE" => $mensagem,
						 	"ENTITYTYPEID" =>  $entity,
						 	"ENTITYID" => $id
						 
						 ));
                
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}

// Chamada da função
// "UF_CRM_1621451360762" => getField('UF_CRM_1621451360762', 'VALOR VINDO DA INTEGRAÇÃO','lead', 1),

function getField($field, $item, $entity, $print = 0){
    
    if($item != ''){
    
        $queryUrl = URL_BX."crm.{$entity}.userfield.list";
    
        $array = array(
                "filter" => array(
                        "FIELD_NAME" => $field
                    )
            );
    
        $result = getJson($queryUrl, $array, $print);
        
        if(isset($result['result'][0]['LIST'][0]['ID'])){
            foreach($result['result'][0]['LIST'] as $key => $value){
                
                $itens[$key] = trim($value['VALUE']);
                $itensId[$key] = $value['ID'];
                        
            }
            $found = array_search(trim($item), $itens);
        }else{
            $found = false;
        }
        
        if($found === false){
    
            updateField($result['result'][0]['ID'], trim($item), $entity, $print);
            $newItem = getField($field,  trim($item), $entity, $print);
            
            return $newItem;
    
        }else{
    
            return $itensId[$found];
        }
    }else{
        return '';
    }

}

function updateField($fieldId, $item, $entity, $print =0){
    
    $queryUrl = URL_BX."crm.{$entity}.userfield.update";
    
    $array = array(
            "ID" => $fieldId,
            "fields" => array(
                        "LIST" => array(array(
                                     "VALUE" => $item
                                    ))
                        ),
        );

    $result = getJson($queryUrl, $array, $print);
    sleep(2);
    
}

function getCompanyByFilter($filter, $type, $print = 0){
    
    if(isset($filter)){

        $queryUrl = URL_BX."crm.company.list";
        
        $fields = Array(
            'filter' => array(
                    '=UF_CRM_1629547940' => trim($filter),
                ),
                'SELECT' => array('UF_*', '*', 'PHONE', 'EMAIL', 'WEB')
            );
            
        $result = getJson($queryUrl, $fields, $print);
        return $result;
    }else{
        
        return '';
    }
}




function getContaByFilters($filter, $empresaOmie, $print = 0){
    
    if(isset($filter)){

        $queryUrl = URL_BX."crm.deal.list";
        
        $fields = Array(
            'filter' => array(
                    '=UF_CRM_1633343937964' => trim($filter),
                    '=COMPANY'  => $empresaOmie
                ),
                'SELECT' => array('UF_*', '*')
            );
            
        $result = getJson($queryUrl, $fields, $print);
        return $result;
    }else{
 
        return '';
        
    }
}





function getPhone($phone){
    
    if($phone == '+55'){
        return '';
    }else{
        return $phone;
    }
    
    
}




###########################################################################
################################## Deal ###################################
###########################################################################


function getDealByFilter($filterText, $print = 0){
    
    if(isset($filterText)){
        
        $queryUrl = URL_BX."crm.deal.list";
        
        $fields = Array(
            'filter' => array(
                    FILTER_DEAL => trim($filterText),
                    'CATEGORY_ID' => CATEGORY_ID,
                ),
                'SELECT' => array('UF_*', '*', 'PHONE', 'EMAIL')
            );
            
        $result = getJson($queryUrl, $fields, $print);
        return $result;
        
    }else{
        return $result['total'] =0;
    }
}

function getDealByFilter2($filterText, $print = 0){
    
    if(isset($filterText)){
        
        $queryUrl = URL_BX."crm.deal.list";
        
        $fields = Array(
            'filter' => array(
                    FILTER_DEAL2 => trim($filterText),
                    'CATEGORY_ID' => CATEGORY_ID,
                ),
                'SELECT' => array('UF_*', '*', 'PHONE', 'EMAIL')
            );
            
        $result = getJson($queryUrl, $fields, $print);
        return $result;
        
    }else{
        return $result['total'] =0;
    }
}



function addDeal($value, $contactAdd, $companyAdd, $transpAdd, $print = 0){
    
    $queryUrl = URL_BX."crm.deal.add";
    $parcelas = '';
    foreach($value['parcelas'] as $keyP => $valueP){
        $nro = $keyP=1;
        $parcelas .= $nro." | ".cleanDate($valueP['parcela']['dataVencimento'])." | ".$valueP['parcela']['valor']." | ".$valueP['parcela']['forma_pagamento']['descricao']." | ".$valueP['parcela']['obs'];
    }
    
    if($value['nota']['numero'] != ''){
        $nfGerada = 1;
    }
        
    $fields = Array(
        'fields' => array(
                'TITLE'             => $value['cliente']['nome'].' - '.$value['origem']['propostaComercial']['numeroProposta'].'/'.$value['numero'],
                'TYPE_ID'           => 'SALE',
                'SOURCE_ID'           => 1,
                'CATEGORY_ID'       => CATEGORY_ID, 
                'CONTACT_ID'        => $contactAdd,
                'COMPANY_ID'        => $companyAdd,
                'UF_CRM_1622026236595'  => $value['numero'],
                'UF_CRM_1622026196949'  => $value['data'].'T00:00:00-03:00',

                "UF_CRM_1622027565084" => getField('UF_CRM_1622027565084', $value['situacao'],'deal', 1), // 'UF_CRM_1622027565084' => getStatus($value['situacao']),

                'UF_CRM_1622026560577' => $value['nota']['numero'],
                'UF_CRM_1622027744586' => $value['nota']['serie'],
                'UF_CRM_1622026597387' => str_replace(' ', 'T', $value['nota']['dataEmissao']).'-03:00',
                'UF_CRM_1622026584633' => $value['nota']['chaveAcesso'],
                'UF_CRM_1622026573679' => $value['nota']['valorNota'],
                'UF_CRM_1620324962'    => $nfGerada,
                
                'UF_CRM_1620323328' => $value['observacoes'],
                'UF_CRM_1620323345' => $value['observacaointerna'],
                'UF_CRM_1620070613' => $value['valorfrete'],
                'UF_CRM_1622026337926' => $value['totalprodutos'],
                'OPPORTUNITY' => $value['totalvenda'],
                'UF_CRM_1622026381926' => str_replace(' ', 'T', $value['dataSaida']).'-03:00',
                'UF_CRM_1622026393667' => str_replace(' ', 'T', $value['dataPrevista']).'-03:00',
                
                'UF_CRM_1614097734403' => $value['origem']['propostaComercial']['numeroProposta'],
                
                'UF_CRM_1620323151' => $parcelas,

                
                
                
            ),
        );
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}

function updateDeal($dealID, $value, $contactAdd, $companyAdd, $transpAdd, $print = 0){
    
    $queryUrl = URL_BX."crm.deal.update";
    $parcelas = '';
    foreach($value['parcelas'] as $keyP => $valueP){
        $nro = $keyP=1;
        $parcelas .= $nro." | ".cleanDate($valueP['parcela']['dataVencimento'])." | ".$valueP['parcela']['valor']." | ".$valueP['parcela']['forma_pagamento']['descricao']." | ".$valueP['parcela']['obs'];
    }
    
    if($value['nota']['numero'] != ''){
        $nfGerada = 1;
    }
        
    $fields = Array(
        'fields' => array(
                'TITLE'             => $value['cliente']['nome'].' - '.$value['origem']['propostaComercial']['numeroProposta'].'/'.$value['numero'],
                'TYPE_ID'           => 'SALE',
                'SOURCE_ID'           => 1,
                'CATEGORY_ID'       => CATEGORY_ID, 
                'CONTACT_ID'        => $contactAdd,
                'COMPANY_ID'        => $companyAdd,
                'UF_CRM_1622026236595'  => $value['numero'],
                'UF_CRM_1622026196949'  => $value['data'].'T00:00:00-03:00',

                "UF_CRM_1622027565084" => getField('UF_CRM_1622027565084', $value['situacao'],'deal', 1), // 'UF_CRM_1622027565084' => getStatus($value['situacao']),

                'UF_CRM_1622026560577' => $value['nota']['numero'],
                'UF_CRM_1622027744586' => $value['nota']['serie'],
                'UF_CRM_1622026597387' => str_replace(' ', 'T', $value['nota']['dataEmissao']).'-03:00',
                'UF_CRM_1622026584633' => $value['nota']['chaveAcesso'],
                'UF_CRM_1622026573679' => $value['nota']['valorNota'],
                'UF_CRM_1620324962'    => $nfGerada,
                
                'UF_CRM_1620323328' => $value['observacoes'],
                'UF_CRM_1620323345' => $value['observacaointerna'],
                'UF_CRM_1620070613' => $value['valorfrete'],
                'UF_CRM_1622026337926' => $value['totalprodutos'],
                'OPPORTUNITY' => $value['totalvenda'],
                'UF_CRM_1622026381926' => str_replace(' ', 'T', $value['dataSaida']).'-03:00',
                'UF_CRM_1622026393667' => str_replace(' ', 'T', $value['dataPrevista']).'-03:00',
                
                'UF_CRM_1614097734403' => $value['origem']['propostaComercial']['numeroProposta'],
                
                'UF_CRM_1620323151' => $parcelas,
                
                
            ),
        'ID' => $dealID['ID'],
        );
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;
}


function setProduct($deal, $items, $print = 0){
    
    $queryUrl = URL_BX."crm.deal.productrows.set";
    $row = array();
    foreach($items as $key => $value){
        
        $row[] = array("ID" => $key,
                        "PRODUCT_NAME" => $value['item']['descricao'],
                        "QUANTITY" => $value['item']['quantidade'],
                        "PRICE" => $value['item']['valorunidade'],
                        "WEIGHT" => $value['item']['pesoBruto'],
                        "DISCOUNT_SUM" => $value['item']['descontoItem']
                        );
        
        
    }
        
    $fields = Array('id' => $deal['ID'],
                    'rows' => $row
        );
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;
    
    
    
}

function getPedidos($dtIni, $dtFim){
    
    $filter = str_replace('/', '%2F', str_replace(' ', '%20', "&filters=dataAlteracao[{$dtIni} TO {$dtFim}]"));
    $i = 1;
    $resultArray = array();
    do{
        $apikey = BLING_API;
        $outputType = "json";
        $url = "https://bling.com.br/Api/v2/pedidos/page={$i}/{$outputType}/?historico=true".$filter.'&apikey=' . $apikey;
        
        printArray($url);
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_URL, $url);
        $result = curl_exec($ch);
        curl_close($ch);
        
        $retorno = json_decode($result,1);
        
        if(isset($retorno['retorno']['erros'])){
            printArray($retorno);
            return 'ERRO';
        }else{
            $resultArray = array_merge($resultArray, $retorno['retorno']['pedidos']);
        }
        
        $i++;
    }while(isset($retorno['retorno']['pedidos'][99]));
    
    return $resultArray;
    
    
    
}

function checkTags($data){
    
    $posC = strpos($data['codigo_cliente_integracao'], 'C');
    $posE = strpos($data['codigo_cliente_integracao'], 'E');


    if(isset($data['codigo_cliente_integracao']) && $posC !== false){
        
        return 'Contato';
        
    }elseif(isset($data['codigo_cliente_integracao']) && $posE !== false){
        
        return 'Empresa';
        
    }else{
    
        if($data['pessoa_fisica'] == 'S'){
            return 'Contato';
        }elseif($data['pessoa_fisica'] == 'N'){
            return 'Empresa';
        }
    }
    
}

function getContactById($filter, $empresaOmie, $print = 0){
    
    if(isset($filter)){

        $queryUrl = URL_BX."crm.contact.list";
        
        $fields = Array(
            'filter' => array(
                    'ID' => trim($filter),
                    'UF_CRM_1631359513'  => $empresaOmie
                ),
                'SELECT' => array('UF_*', '*', 'PHONE', 'EMAIL', 'WEB')
            );
            
        $result = getJson($queryUrl, $fields, $print)['result'][0];
        return $result;
    }else{
 
        return '';
        
    }
}

function getCompanyById($filter, $print = 0){
    
    if(isset($filter)){

        $queryUrl = URL_BX."crm.company.list";
        
        $fields = Array(
            'filter' => array(
                    'ID' => trim($filter),
                ),
                'SELECT' => array('UF_*', '*', 'PHONE', 'EMAIL', 'WEB')
            );
            
        $result = getJson($queryUrl, $fields, $print)['result'][0];
        return $result;
    }else{
 
        return '';
        
    }
}


function getCompanyByOmieKey($filter, $print = 0){
    
    if(isset($filter)){

        $queryUrl = URL_BX."crm.company.list";
        
        $fields = Array(
            'filter' => array(
                    '=UF_CRM_1631356971' => trim($filter),
                ),
                'SELECT' => array('ID')
            );
            
        $result = getJson($queryUrl, $fields, $print)['result'][0];
        return $result;
    }else{
 
        return '';
        
    }
}



function phonesUpdate($oldPhones, $newPhone, $type = 'WORK'){
    
    writeToLog($oldPhones, "OLD PHONES");
    
    if(isset($newPhone) && $newPhone != ''){
    
        $found = false;
        foreach($oldPhones as $key => $value){
            if($value['VALUE'] == $newPhone){
                $found = true;        
            }
        }
        
        if($found == false){
            
            $oldPhones[] = array(
                            'VALUE_TYPE' => $type,
                            'VALUE'      => $newPhone
                );
            
        }
        
        return $oldPhones;
        
    }else{
        return $oldPhones;
    }
    
}

function updateCompany($data, $oldId, $print = 0){
    
    $queryUrl = URL_BX."crm.company.update";
    
    $fields = Array(
        'fields' => $data,
        'ID' => $oldId);
        
    writeToLog($fields, "UPDATE Company");
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}

function addCompany($data, $print = 0){
    
    $queryUrl = URL_BX."crm.company.add";
    
    $fields = Array(
        'fields' => $data
        );
        
    writeToLog($fields, "Add Company");
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}

function deleteCompany($data, $print = 0){
    
    $queryUrl = URL_BX."crm.company.delete";
    
    $fields = Array(
        'id' => $data
        );
        
    writeToLog($fields, "Deleta Contact");
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}

function updateConta($data, $oldId, $print = 0){
    
    $queryUrl = URL_BX."crm.deal.update";
    
    $fields = Array(
        'fields' => $data,
        'ID' => $oldId);
        
    writeToLog($fields, "UPDATE Deal");
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}

function addContact($data, $print = 0){
    
    $queryUrl = URL_BX."crm.contact.add";
    
    $fields = Array(
        'fields' => $data
        );
        
    writeToLog($fields, "Add Contact");
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}

function deleteContact($data, $print = 0){
    
    $queryUrl = URL_BX."crm.contact.delete";
    
    $fields = Array(
        'id' => $data
        );
        
    writeToLog($fields, "Deleta Contact");
        
    $result = getJson($queryUrl, $fields, $print);
    return $result;

}



function getSimNao($value){
    
    if($value == 'S'){
        return 0;
    }elseif($value == 'N'){
        return 1;
    }else{
        return 1;
    }
}

function getTypeOmie($tags){
    
    foreach($tags as $key => $value){
        
        if($value['tag'] == 'Cliente'){
            
            return "CLIENT";
            
        }elseif($value['tag'] == 'Fornecedor'){
            
            return "SUPPLIER";
        }
        
        
    }
    
}
      
###########################################################################
#################################### Inicio ###############################
###########################################################################
// Array
// (
//     [messageId] => 9c6ff0b8-3353-5247-9283-a95b618b1b7b
//     [topic] => Financas.ContaReceber.BaixaRealizada
//     [event] => Array
//         (
//             [0] => Array
//                 (
//                     [codigo_baixa] => 1240820960
//                     [codigo_baixa_integracao] => 
//                     [codigo_conta_corrente] => 838477684
//                     [conta_a_receber] => Array
//                         (
//                             [0] => Array
//                                 (
//                                     [codigo_lancamento_integracao] => 
//                                     [codigo_lancamento_omie] => 1240820921
//                                     [data_emissao] => 2021-10-15T00:00:00-03:00
//                                     [data_entrada] => 2021-10-15T00:00:00-03:00
//                                     [data_vencimento] => 2021-10-01T00:00:00-03:00
//                                     [numero_documento] => 
//                                     [numero_documento_fiscal] => 
//                                     [numero_parcela] => 001/001
//                                     [valor_documento] => 12
//                                 )

//                         )

//                     [data] => 2021-10-15T00:00:00-03:00
//                     [data_cred] => 2021-10-15T00:00:00-03:00
//                     [desconto] => 12
//                     [juros] => 12
//                     [multa] => 12
//                     [observacao] => obs recebimento
//                     [tarifa] => 0
//                     [valor] => 24
//                 )

//         )

//     [author] => Array
//         (
//             [email] => equipe@bytebio.com
//             [name] => Equipe Bytebio
//             [userId] => 304816
//         )

//     [appKey] => 1385372947959
//     [appHash] => mundo-gsqgjvh
//     [origin] => omie-connect-1.6
// )


date_default_timezone_set("America/Sao_Paulo");

writeToLog($_REQUEST, "Request entrada");

$data = file_get_contents('php://input'); 
writeToLog($data, "Body entrada");
$data = json_decode($data, 1);
writeToLog($data, "Body entrada");

if($_REQUEST['tkn'] != TKN){
    writeToLog($_REQUEST['tkn'], "Token Inválido");
    exit();
}

$empresa = getCompanyByOmieKey(trim($data['appKey']), 1);

printArray($empresa);

$conta = getContaByFilters($data['event'][0]['conta_a_receber'][0]['codigo_lancamento_omie'], $empresa['ID'], 1);

printArray($conta);

if($data['topic'] == 'Financas.ContaReceber.BaixaRealizada' && isset($conta['result'][0]['ID'])){
    
    $dataConta = array(    
        "UF_CRM_1634290781069"      => $data['event'][0]['data'],
        "UF_CRM_1634290799491"      => $data['event'][0]['desconto'],
        "UF_CRM_1634290810920"      => $data['event'][0]['juros'],
        "UF_CRM_1634290822672"      => $data['event'][0]['multa'],
        "UF_CRM_1634290850052"      => $data['event'][0]['tarifa'],
        "UF_CRM_1634290861487"      => $data['event'][0]['valor'],
        "UF_CRM_1634290894095"      => $data['event'][0]['codigo_baixa'],
        "UF_CRM_1634290839127"      => $data['event'][0]['observacao'],
        "UF_CRM_1634292767033"      => 2914, // Baixado
    );
    
    writeToLog($dataConta, "Dados Conta Update");
    
    updateConta($dataConta, $conta['result'][0]['ID'], 1);
    
    $mensagem = "[B]Conta Baixada via Omie[/B]
    
Data Baixa: ".cleanDate($data['event'][0]['data'])."
Desconto: ".$data['event'][0]['desconto']."
Juros: ".$data['event'][0]['juros']."
Multa: ".$data['event'][0]['multa']."
Tarifa: ".$data['event'][0]['tarifa']."
Valor Baixado: ".$data['event'][0]['valor']."
Observações: ".$data['event'][0]['observacao'];
    
    addFeed($conta['result'][0]['ID'], $mensagem, 2, 1);
        
}elseif($data['topic'] == 'Financas.ContaPagar.BaixaRealizada' && isset($conta['result'][0]['ID'])){
    
    $dataConta = array(    
        "UF_CRM_1634290781069"      => $data['event'][0]['data'],
        "UF_CRM_1634290799491"      => $data['event'][0]['desconto'],
        "UF_CRM_1634290810920"      => $data['event'][0]['juros'],
        "UF_CRM_1634290822672"      => $data['event'][0]['multa'],
        "UF_CRM_1634290850052"      => $data['event'][0]['tarifa'],
        "UF_CRM_1634290861487"      => $data['event'][0]['valor'],
        "UF_CRM_1634290894095"      => $data['event'][0]['codigo_baixa'],
        "UF_CRM_1634290839127"      => $data['event'][0]['observacao'],
        "UF_CRM_1634292767033"      => 2914, // Baixado
    );
    
    writeToLog($dataConta, "Dados Conta Update");
    
    updateConta($dataConta, $conta['result'][0]['ID'], 1);
    
    $mensagem = "[B]Conta Baixada via Omie[/B]
    
Data Baixa: ".cleanDate($data['event'][0]['data'])."
Desconto: ".$data['event'][0]['desconto']."
Juros: ".$data['event'][0]['juros']."
Multa: ".$data['event'][0]['multa']."
Tarifa: ".$data['event'][0]['tarifa']."
Valor Baixado: ".$data['event'][0]['valor']."
Observações: ".$data['event'][0]['observacao'];
    
    addFeed($conta['result'][0]['ID'], $mensagem, 2, 1);
        
}




?>